'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

var _httpErrors = require('http-errors');

var _httpErrors2 = _interopRequireDefault(_httpErrors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * RegExp to match an Object-opening brace "{" as the first non-space
 * in a string. Allowed whitespace is defined in RFC 7159:
 *
 *     x20  Space
 *     x09  Horizontal tab
 *     x0A  Line feed or New line
 *     x0D  Carriage return
 */

/**
 *  Fork Copyright (c) 2016, Martin Heidegger,
 *
 *  Original Copyright (c) 2015, Facebook, Inc.
 *  All rights reserved.
 *
 *  This source code is licensed under the BSD-style license found in the
 *  LICENSE file in the root directory of this source tree. An additional grant
 *  of patent rights can be found in the PATENTS file in the same directory.
 */
var jsonObjRegex = /^[\x20\x09\x0a\x0d]*\{/;

exports.default = {
  'application/graphql': function applicationGraphql(body) {
    return { query: body };
  },
  'application/json': function applicationJson(body) {
    if (jsonObjRegex.test(body)) {
      /* eslint-disable no-empty */
      try {
        return JSON.parse(body);
      } catch (error) {}
      // Do nothing

      /* eslint-enable no-empty */
    }
    throw (0, _httpErrors2.default)(400, 'POST body sent invalid JSON.');
  },
  'application/x-www-form-urlencoded': function applicationXWwwFormUrlencoded(body) {
    return _querystring2.default.parse(body);
  }
};